<template>
    <div
        class="tab-pane fade"
        id="v-pills-profile"
        role="tabpanel"
        aria-labelledby="v-pills-profile-tab"
    >
        <div class="card m-b-30">
            <div class="card-header">
                <h5 class="card-title mb-0">Mi perfil</h5>
            </div>
            <div class="card-body">
                <div class="profilebox pt-4 text-center">
                    <ul class="list-inline">
                        <li class="list-inline-item">
                            <a href="#" class="btn btn-success-rgba font-18"
                                ><i class="feather icon-edit"></i
                            ></a>
                        </li>
                        <li class="list-inline-item">
                            <img
                                src="assets\images\users\profile.svg"
                                class="img-fluid"
                                alt="profile"
                            />
                        </li>
                        <li class="list-inline-item">
                            <a href="#" class="btn btn-danger-rgba font-18"
                                ><i class="feather icon-trash"></i
                            ></a>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
        <div class="card m-b-30">
            <div class="card-header">
                <h5 class="card-title mb-0">
                    Información básica
                </h5>
            </div>
            <div class="card-body">
                <form method="POST" v-on:submit.prevent="updateUser(users.id)">
                    <div class="form-row">
                        <div class="form-group col-md-6">
                            <label for="firstname">Nombre</label>
                            <input
                                type="text"
                                class="form-control"
                                id="firstname"
                                v-model="user.firstname"
                            />
                        </div>
                        <div class="form-group col-md-6">
                            <label for="lastname">Apellido</label>
                            <input
                                type="text"
                                class="form-control"
                                id="lastname"
                                v-model="user.lastname"
                            />
                        </div>
                    </div>
                    <div class="form-row">
                        <div class="form-group col-md-6">
                            <label for="usermobile">Correo electrónico</label>
                            <input
                                type="text"
                                class="form-control"
                                id="email"
                                v-model="user.email"
                            />
                        </div>
                        <div class="form-group col-md-6">
                            <label for="role">Tipo de usuario</label>
                            <input
                                type="text"
                                class="form-control"
                                id="role"
                                disabled
                                v-bind:value="
                                    user.role == 10
                                        ? 'Estudiante'
                                        : 'Administrador'
                                "
                            />
                        </div>
                    </div>
                    <div class="form-row">
                        <div class="form-group col-md-6">
                            <label for="userpassword">Contraseña</label>
                            <input
                                type="password"
                                class="form-control"
                                id="userpassword"
                            />
                        </div>
                        <div class="form-group col-md-6">
                            <label for="userconfirmedpassword"
                                >Confirmar contraseña</label
                            >
                            <input
                                type="password"
                                class="form-control"
                                id="userconfirmedpassword"
                            />
                        </div>
                    </div>

                    <button type="submit" class="btn btn-primary-rgba font-16">
                        <i class="feather icon-save mr-2"></i>Actualizar
                    </button>
                </form>
            </div>
        </div>
        <div class="card m-b-30">
            <div class="card-header">
                <h5 class="card-title mb-0">
                    Información adicional
                </h5>
            </div>
            <div class="card-body">
                <form method="POST" v-on:submit.prevent="updateInfo(user.id)">
                    <div class="form-row">
                        <div class="form-group col-md-6">
                            <label for="birthday">Fecha de nacimiento</label>
                            <input
                                type="date"
                                class="form-control"
                                id="birthday"
                                name="birthday"
                                v-model="info.birthday"
                                v-bind:max="min"
                            />
                        </div>
                        <div class="form-group col-md-6">
                            <label for="lastname">whatsapp</label>
                            <div class="input-group">
                                <input
                                    type="text"
                                    class="form-control"
                                    id="whatsapp"
                                    name="whatsapp"
                                    v-model="info.whatsapp"
                                />
                                <div class="input-group-append">
                                    <span
                                        class="input-group-text"
                                        id="basic-addon2"
                                        ><i class="ion ion-logo-whatsapp"></i
                                    ></span>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="form-row">
                        <div class="form-group col-md-6">
                            <label for="usermobile">Pais</label>
                            <select
                                class="form-control"
                                v-model="info.pais"
                                v-on:change="getStates"
                            >
                                <option
                                    v-for="item in country"
                                    :key="item.id"
                                    :value="item.id"
                                    >{{ item.name }}</option
                                >
                            </select>
                        </div>
                        <div v-if="info.pais" class="form-group col-md-6">
                            <label for="usermobile">Ciudad/Provincia</label>
                            <select
                                class="select2-single form-control"
                                name="state"
                                v-model="info.ciudad"
                            >
                                <option
                                    v-for="item in states"
                                    :key="item.id"
                                    :value="item.id"
                                    >{{ item.name }}</option
                                >
                            </select>
                        </div>
                    </div>

                    <button type="submit" class="btn btn-primary-rgba font-16">
                        <i class="feather icon-save mr-2"></i
                        >{{ info.id ? "Actualizar" : "Guardar" }}
                    </button>
                </form>
            </div>
        </div>
    </div>
</template>

<script>
export default {
    props: ["users"],
    created: async function() {
        this.getUser();
        await this.getInfo();
        this.getCountry();
        this.getMinDate();
    },
    mounted() {},
    data() {
        return {
            user: [],
            country: [],
            min: "",
            info: {
                birthday: "",
                whatsapp: "",
                pais: "",
                ciudad: "",
                user_id: ""
            },
            states: []
        };
    },
    methods: {
        getUser() {
            var url = "/api/users/" + this.users.id + "/edit";
            axios.get(url).then(res => {
                this.user = res.data;
            });
        },
        getInfo() {
            var url = "/api/users/info/" + this.users.id + "/edit";
            axios.get(url).then(res => {
                if (res.data.pais) {
                    this.info = res.data;
                    this.getStates();
                }
            });
        },
        getCountry: function() {
            var url = "/api/citizen";
            axios.get(url).then(res => {
                this.country = res.data.countries;
            });
        },
        getMinDate() {
            var today = new Date(Date.now());
            var mes = today.getMonth() + 1;
            if (mes < 10) {
                mes = "0" + mes;
            }
            this.min =
                today.getFullYear() - 13 + "-" + mes + "-" + today.getDate();
        },
        getStates() {
            var url = "/api/citizen/states";
            axios.get(url).then(res => {
                this.states = res.data.states.filter(
                    state => state.id_country == this.info.pais
                );
            });
        },
        updateUser: function(user) {
            var url = "/api/users/" + this.user.id;
            if (user.password && user.password.length < 8) {
                this.error = "La contraseña debe se mayor a 8 caracteres";
            } else {
                axios
                    .put(url, this.user)
                    .then(res => {
                        if (res.data.error) {
                            this.error = res.data.error;
                            $("#errorAlert").show();
                        } else {
                            window.location.reload();
                        }
                    })
                    .catch(err => {
                        console.log(err);
                    });
            }
        },
        updateInfo: function(user) {
            if (!this.info.id) {
                var url = "/api/users/info";
                this.info.user_id = user;
                axios.post(url, this.info).then(res => {
                    this.getInfo();
                });
            } else {
                var url = "/api/users/info/" + this.info.id;
                axios
                    .put(url, this.info)
                    .then(res => {
                        this.getInfo();
                    })
                    .catch(err => {
                        console.log(err);
                    });
            }
        }
    },
    ready: function() {
        getStates();
    }
};
</script>
